PROGRAM Compile_CRACK;
USES GUtils, LZH;

CONST
  PatternSize = 50;
  MaxCrack    = 20;

TYPE
  TByteData = RECORD
      Search : STRING[PatternSize];
     Replace : STRING[PatternSize];
  END;
  TCrackData = RECORD
        Logo : ARRAY[1..4000] OF Byte;
      YCoord : Byte;
  CrackTotal : Byte;
    FileName : STRING[12];
        Data : ARRAY[1..MaxCrack] OF TByteData;
  END;
  TCrackID   = RECORD
        Size : Word;
          ID : LongInt;
  END;


VAR
  InFile          : FILE;
  OutFile         : FILE;
  CrackData       : TCrackData;
  CrackID         : TCrackID;

  ScriptFileName  : STRING;
  CompileFileName : STRING;


  PROCEDURE Error(Msg:STRING);
  BEGIN
    WriteLn(MSG);
    Halt(1)
  END;


{$F+}
  PROCEDURE ReadNextBlock; {This routine handles reading of input data}
  BEGIN
    BlockRead(InFile,LZHMem^.InBuf,SizeOf(LZHMem^.InBuf),LZHMem^.InEnd);
    IF IoResult > 0 THEN Error('Error reading input file.');
  END;

  PROCEDURE WriteNextBlock; {This routine handles reading of output data}
  VAR Written:Word;
  BEGIN
    BlockWrite(OutFile,LZHMem^.OutBuf,LZHMem^.OutPtr, Written);
    IF (IOResult > 0) OR (Written < LZHMem^.OutPtr)
      THEN Error('Error writing output file.');
  END;

  PROCEDURE OpenInput(Fn:STRING);
  BEGIN
    Assign(InFile,FN);
    Reset(InFile,1);
    IF IOResult > 0 THEN Error('Can''t open '+Fn+' file');
  END;

  PROCEDURE OpenOutput(Fn:STRING);
  BEGIN
    Assign(OutFile,Fn); Rewrite(OutFile,1);
    IF IOResult > 0 THEN Error('Can''t open '+Fn+' file');
  END;
{---------------------------------------------------------------------------}






{---------------------------------------------------------------------------}
{---------------------------------------------------------------------------}
{---------------------------------------------------------------------------}
PROCEDURE InitFindReplace(VAR NEW_Find,NEW_Replace:STRING);
VAR I,R: Byte; S1,S2: STRING[2];
BEGIN
  NEW_Find    := StripAll(NEW_Find   ,' ');
  NEW_Replace := StripAll(NEW_Replace,' ');
  IF Odd(Length(NEW_Find))    THEN NEW_Find[0]    := Chr(Ord(NEW_Find[0])-1);
  IF Odd(Length(NEW_Replace)) THEN NEW_Replace[0] := Chr(Ord(NEW_Replace[0])-1);
  R := 0;
  FOR I := 1 TO Length(NEW_Find) DO
  BEGIN
    S1 := Copy(NEW_Find   ,I,2);
    S2 := Copy(NEW_Replace,I,2);
    Inc(I); Inc(R);
    NEW_Find   [R] := Chr(HexToDec(S1));
    NEW_Replace[R] := Chr(HexToDec(S2));
  END;
  NEW_Find[0]    := Chr(Ord(NEW_Find[0])    DIV 2);
  NEW_Replace[0] := Chr(Ord(NEW_Replace[0]) DIV 2);
END;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE GenerateCrackData;
VAR ScriptFile:Text; LogoFile:FILE; Crk:FILE; Line,Fnd,Rep:STRING[80];
BEGIN
  FillChar(CrackData, SizeOf(CrackData), 0);
  Writeln('Compiling script file ',ScriptFileName,' to ',CompileFileName);
  Writeln;
  Assign(ScriptFile,ScriptFileName);
  {$I-}
    Reset(ScriptFile);
  {$I+}
  IF IOResult <> 0 THEN Error('Error openning '+ScriptFileName);
  ReadLn(ScriptFile,Line);
  Writeln('Script name    : ',Line);
  ReadLn(ScriptFile,Line);
           Assign(LogoFile,Line);
           {$I-} Reset(LogoFile,1); {$I+}
           IF IOResult <> 0 THEN Error('SCRIPT FILE ERROR: Error openning '+Line);
           BlockRead(LogoFile,CrackData.Logo,SizeOf(CrackData.Logo));
           Close(LogoFile);
  Writeln('Logo file      : ',Line);
  ReadLn(ScriptFile,Line); CrackData.YCoord := StrToInt(Line);
  Writeln('Cursor YPos    : ',CrackData.YCoord);
  ReadLn(ScriptFile,Line); CrackData.FileName := Line;
  Writeln('Search in file : ',CrackData.FileName);
  REPEAT
    Inc(CrackData.CrackTotal);
    ReadLn(ScriptFile,Fnd);
    ReadLn(ScriptFile,Rep);
    ReadLn(ScriptFile,Line); {!!!!!!!!!!!!}
    InitFindReplace(Fnd,Rep);
    CrackData.Data[CrackData.CrackTotal].Search  := Fnd;
    CrackData.Data[CrackData.CrackTotal].Replace := Rep;
    IF CrackData.CrackTotal = MaxCrack THEN Break;
  UNTIL Eof(ScriptFile);
  Close(ScriptFile);
  Writeln('Search patterns: ',CrackData.CrackTotal);

  Assign(Crk,'$TEMP$.$!$');
  Rewrite(Crk,1);
  BlockWrite(Crk,CrackData,SizeOf(CrackData));
  Close(Crk);
END;



PROCEDURE FixFiles;
VAR F:FILE; Readen:Word;
BEGIN
  RenameFile(CompileFileName,'$TEMP$.$$$');
  CopyFile('CRACK.OVL',CompileFileName);

  Assign(F,'$TEMP$.$$$'); Reset(F,1);
  BlockRead(F,CrackData,SizeOf(CrackData),Readen);
  Close(F);

  Assign(F,CompileFileName); Reset(F,1);
  Seek(F,FileSize(F));
  BlockWrite(F,CrackData,Readen);
  Close(F);

  DeleteFile('$TEMP$.$!$');
  DeleteFile('$TEMP$.$$$');
END;



{***************************************************************************}
{****************************** MAIN PROGRAM *******************************}
{***************************************************************************}
BEGIN
  Writeln('EASY CRACK v1.0');
  Writeln('Copyright (C) 1997 by The GodFather');
  Writeln;
  IF NOT Exist('CRACK.OVL')
    THEN Error('ERROR: CRACK.OVL must be in current directory!');

  IF ParamCount < 2
    THEN Error('Usage: EC [script_file_name] [crack_file_name]');

  ScriptFileName  := AdjCase(Upper, ParamStr(1));
  CompileFileName := AdjCase(Upper, BaseNameOnly(ParamStr(2))+'.EXE');

  GenerateCrackData;
  WriteFromBuffer := WriteNextBlock;
  ReadToBuffer    := ReadNextBlock;
  InitLZH;
  LZHMem^.OutEnd := SizeOf(LZHMem^.OutBuf);
  LZHMem^.OutPtr := 0;

  OpenInput('$TEMP$.$!$');
  OpenOutput(CompileFileName);
  LZHMem^.Ebytes:= filesize(InFile);
  Encode;
  CrackID.Size := FileSize(OutFile);
  CrackID.ID   := $43454647;
  BlockWrite(OutFile,CrackID,SizeOF(CrackID));
  Close(InFile);
  Close(OutFile);
  DInitLZH;
  FixFiles;
  Writeln;
  Writeln(CompileFileName,' is created.');
END.