{$A+,B-,D+,E+,F+,I-,L-,N-,R-,S-,V-}
{$M 1024,60000,60000}
PROGRAM LZH_Test;

USES
  LZH;

VAR
  InFile,
  OutFile : FILE;
  Action  : Char;


  PROCEDURE Error(Msg:STRING);
  BEGIN
    WriteLn(MSG);
    Halt(1)
  END;


{$F+}
  PROCEDURE ReadNextBlock; {This routine handles reading of input data}
  BEGIN
    BlockRead(InFile,LZHMem^.InBuf,SizeOf(LZHMem^.InBuf),LZHMem^.InEnd);
    IF IoResult > 0 THEN Error('! Error reading input file');
  END;

  PROCEDURE WriteNextBlock; {This routine handles reading of output data}
  VAR Written:Word;
  BEGIN
    BlockWrite(OutFile,LZHMem^.OutBuf,LZHMem^.OutPtr, Written);
    IF (IoResult > 0) OR (Written < LZHMem^.OutPtr)
      THEN Error('! Error writing output file');
  END;





{---------------------------------------------------------------------------}
  PROCEDURE OpenInput(fn: STRING);
  BEGIN
    assign(infile,fn); reset(infile,1);
    if IoResult>0 then Error('! Can''t open input file');
  END;

  PROCEDURE OpenOutput (fn: STRING);
  BEGIN
    assign(outfile,fn); rewrite(outfile,1);
    if IoResult>0 then Error('! Can''t open output file');
  END;




{---------------------------------------------------------------------------}
{---------------------------------------------------------------------------}
{---------------------------------------------------------------------------}
BEGIN
   WriteFromBuffer := WriteNextBlock;
   ReadToBuffer    := ReadNextBlock;

   InitLZH; {This routine should be called before any LZHMem calls}
   LZHMem^.OutEnd := SizeOf(LZHMem^.OutBuf);
   LZHMem^.OutPtr := 0;

   OpenInput('gsuper.!!!');
   OpenOutput('gsuper.arc');

   Action := 'a';
   CASE S OF
      'A','a': BEGIN
                 LZHMem^.Ebytes:= filesize(infile);
                 Writeln (LZHMem^.Ebytes);
                 Encode;     {Call black box routine to compress}
                 Writeln ('input:  ', LZHMem^.textsize, ' bytes');
                 Writeln ('output: ', LZHMem^.codesize, ' bytes');
                 Writeln ('relative output: ', LZHMem^.codesize*100 div LZHMem^.textsize, '%');
              END;
     'X','x': Decode;   {Call routine to decompress}
   END;
   Close(InFile);
   Close(OutFile);
   DInitLZH;
END.
